<?php
$flickrpress_url = get_bloginfo('wpurl') . '/wp-content/plugins/flickrpress';

function flickrpress_mce_buttons($buttons) {
	array_push($buttons, "flickrpress");
	return $buttons;
}

function flickrpress_mce_external_plugins($plugins) {
	global $flickrpress_url;
	$plugins['flickrpress'] = $flickrpress_url . '/tinymce/v3/editor_plugin.js';
	return $plugins;
}

// Add quicktags for html source editor. To add more buttons, replicate the stuff between the Start and End comments. 
function flickrpress_add_quicktags() {
echo <<<EOT
<script type="text/javascript">
// <![CDATA[
if ( typeof tinyMCE == "undefined" ){
	if(flickrpressToolbar = document.getElementById("ed_toolbar")){
		var flickrpressNr, flickrpressBut, flickrpressStart, flickrpressEnd;
		// Start button 1
		flickrpressStart = '';
		flickrpressEnd = '';
		flickrpressNr = edButtons.length;
		// This is the label that appears on the button in Code view
		edButtons[flickrpressNr] = new edButton('ed_flickrpress0','flickrpress','', '','','-1');
		var flickrpressBut = flickrpressToolbar.lastChild;
		while (flickrpressBut.nodeType != 1){
			flickrpressBut = flickrpressBut.previousSibling;
		}
		flickrpressBut = flickrpressBut.cloneNode(true);
		flickrpressToolbar.appendChild(flickrpressBut);
		flickrpressBut.value = 'flickrpress';
		// the title for your button (aka tooltip)
		flickrpressBut.title = 'Browse and Insert flickr Photos';
		// the name of the function your button should run
		flickrpressBut.onclick = function() {edflickrpress();}
		flickrpressBut.id = "ed_flickrpress0";
		flickrpressStart = '';
		flickrpressEnd = '';
		// End button 1
	}
}
// ]]>
</script>
EOT;
}
// Load the javascript for the popup tool. This runs when the button is clicked - it launches the Filez popup tool. If you're borrowing this code, you may or may not want to launch a file like this - if your tool is simple enough you could do the whole popup with some javascript instead.
function flickrpress_popup_javascript() {
	echo '
<script type="text/javascript">
//<![CDATA[
function edflickrpress() {
	var mylink = "' . get_bloginfo('wpurl') . '/wp-content/plugins/flickrpress/popup.php?action=users";
	var windowname = "flickrpress";
	if (! window.focus) return true;
		var href;
	if (typeof(mylink) == "string")
		href = mylink;
	else
		href = mylink.href;
		ppopupwin = window.open(href, windowname, "width=400,height=600,scrollbars=yes,toolbar=no,menubar=no,resizable=yes");
		ppopupwin.focus();
		return false;
}
//]]>
</script>
';
}

// Actions and filters to connect the plugin with WP.
add_action('admin_print_scripts', 'flickrpress_popup_javascript');
add_action('admin_footer', 'flickrpress_add_quicktags');
add_filter( 'mce_external_plugins', 'flickrpress_mce_external_plugins');
add_filter( 'mce_buttons_3', 'flickrpress_mce_buttons');

?>
